angular.module('starter.controllers', ['sj'])

.controller('LoginController', function($scope, $stateParams, $state, $rootScope, $ionicHistory, Sj, Obj, Dialog, LocalStorage) {
    if(LocalStorage.get('email')){
        $ionicHistory.goBack();
    }

    if($stateParams.error){
        $scope.showLoginMsg = true;
        $scope.showRegisterMsg = true;
    }

    $scope.closeLoginMsg = function(){
        $scope.showLoginMsg = false;
    }

    $scope.closeRegisterMsg = function(){
        $scope.showRegisterMsg = false;
    }

    $scope.login = function(loginForm, user){
        if(loginForm.$valid == false){            
            return false;
        }
        Sj.checkUser(user).then(function(data){
            if(Obj.size(data)<1){
                Dialog.alert('User does not exist');
                return false;
            } 
            LocalStorage.set('email', data[0].emailaddress);
            LocalStorage.set('id', data[0].id);
            LocalStorage.set('firstname', data[0].firstname);
            $rootScope.$broadcast('authenticated', LocalStorage.get('firstname'));
            
            if($stateParams.error){
                $state.go('apply', { jobid: $stateParams.jobid, agency_id:$stateParams.agency_id});
            }
            else{
                $state.go('home');
            }
        }); 
    }
})

.controller('RegisterController', function($scope, $state, $filter, $ionicModal, $ionicHistory, $rootScope, $ionicPlatform,$ionicScrollDelegate, Sj, Obj, Jobs, Dialog, LocalStorage, Toast) {
    $ionicPlatform.registerBackButtonAction(function (event) {
        if($state.current.name=="register"){
            Dialog.confirm('Cancel Registration', 'Cancel your registration?', function(res){ 
               if(res ==1) 
               {
                    navigator.app.backHistory();
               }
            });
        }
        else{
            navigator.app.backHistory();
        }
    }, 100);
    LocalStorage.remove('page1');
    LocalStorage.remove('page2');
    LocalStorage.remove('page3');
    Jobs.removeAll('seaExperience');
    Jobs.removeAll('landExperience');

    $scope.countries=[{name:"Afghanistan",dial_code:"+93",code:"AF"},{name:"Albania",dial_code:"+355",code:"AL"},{name:"Algeria",dial_code:"+213",code:"DZ"},{name:"AmericanSamoa",dial_code:"+1 684",code:"AS"},{name:"Andorra",dial_code:"+376",code:"AD"},{name:"Angola",dial_code:"+244",code:"AO"},{name:"Anguilla",dial_code:"+1 264",code:"AI"},{name:"Antigua and Barbuda",dial_code:"+1268",code:"AG"},{name:"Argentina",dial_code:"+54",code:"AR"},{name:"Armenia",dial_code:"+374",code:"AM"},{name:"Aruba",dial_code:"+297",code:"AW"},{name:"Australia",dial_code:"+61",code:"AU"},{name:"Austria",dial_code:"+43",code:"AT"},{name:"Azerbaijan",dial_code:"+994",code:"AZ"},{name:"Bahamas",dial_code:"+1 242",code:"BS"},{name:"Bahrain",dial_code:"+973",code:"BH"},{name:"Bangladesh",dial_code:"+880",code:"BD"},{name:"Barbados",dial_code:"+1 246",code:"BB"},{name:"Belarus",dial_code:"+375",code:"BY"},{name:"Belgium",dial_code:"+32",code:"BE"},{name:"Belize",dial_code:"+501",code:"BZ"},{name:"Benin",dial_code:"+229",code:"BJ"},{name:"Bermuda",dial_code:"+1 441",code:"BM"},{name:"Bhutan",dial_code:"+975",code:"BT"},{name:"Bosnia and Herzegovina",dial_code:"+387",code:"BA"},{name:"Botswana",dial_code:"+267",code:"BW"},{name:"Brazil",dial_code:"+55",code:"BR"},{name:"British Indian Ocean Territory",dial_code:"+246",code:"IO"},{name:"Bulgaria",dial_code:"+359",code:"BG"},{name:"Burkina Faso",dial_code:"+226",code:"BF"},{name:"Burundi",dial_code:"+257",code:"BI"},{name:"Cambodia",dial_code:"+855",code:"KH"},{name:"Cameroon",dial_code:"+237",code:"CM"},{name:"Canada",dial_code:"+1",code:"CA"},{name:"Cape Verde",dial_code:"+238",code:"CV"},{name:"Cayman Islands",dial_code:"+ 345",code:"KY"},{name:"Central African Republic",dial_code:"+236",code:"CF"},{name:"Chad",dial_code:"+235",code:"TD"},{name:"Chile",dial_code:"+56",code:"CL"},{name:"China",dial_code:"+86",code:"CN"},{name:"Christmas Island",dial_code:"+61",code:"CX"},{name:"Colombia",dial_code:"+57",code:"CO"},{name:"Comoros",dial_code:"+269",code:"KM"},{name:"Congo",dial_code:"+242",code:"CG"},{name:"Cook Islands",dial_code:"+682",code:"CK"},{name:"Costa Rica",dial_code:"+506",code:"CR"},{name:"Croatia",dial_code:"+385",code:"HR"},{name:"Cuba",dial_code:"+53",code:"CU"},{name:"Cyprus",dial_code:"+537",code:"CY"},{name:"Czech Republic",dial_code:"+420",code:"CZ"},{name:"Denmark",dial_code:"+45",code:"DK"},{name:"Djibouti",dial_code:"+253",code:"DJ"},{name:"Dominica",dial_code:"+1 767",code:"DM"},{name:"Dominican Republic",dial_code:"+1 849",code:"DO"},{name:"Ecuador",dial_code:"+593",code:"EC"},{name:"Egypt",dial_code:"+20",code:"EG"},{name:"El Salvador",dial_code:"+503",code:"SV"},{name:"Equatorial Guinea",dial_code:"+240",code:"GQ"},{name:"Eritrea",dial_code:"+291",code:"ER"},{name:"Estonia",dial_code:"+372",code:"EE"},{name:"Ethiopia",dial_code:"+251",code:"ET"},{name:"Faroe Islands",dial_code:"+298",code:"FO"},{name:"Fiji",dial_code:"+679",code:"FJ"},{name:"Finland",dial_code:"+358",code:"FI"},{name:"France",dial_code:"+33",code:"FR"},{name:"French Guiana",dial_code:"+594",code:"GF"},{name:"French Polynesia",dial_code:"+689",code:"PF"},{name:"Gabon",dial_code:"+241",code:"GA"},{name:"Gambia",dial_code:"+220",code:"GM"},{name:"Georgia",dial_code:"+995",code:"GE"},{name:"Germany",dial_code:"+49",code:"DE"},{name:"Ghana",dial_code:"+233",code:"GH"},{name:"Gibraltar",dial_code:"+350",code:"GI"},{name:"Greece",dial_code:"+30",code:"GR"},{name:"Greenland",dial_code:"+299",code:"GL"},{name:"Grenada",dial_code:"+1 473",code:"GD"},{name:"Guadeloupe",dial_code:"+590",code:"GP"},{name:"Guam",dial_code:"+1 671",code:"GU"},{name:"Guatemala",dial_code:"+502",code:"GT"},{name:"Guinea",dial_code:"+224",code:"GN"},{name:"Guinea-Bissau",dial_code:"+245",code:"GW"},{name:"Guyana",dial_code:"+595",code:"GY"},{name:"Haiti",dial_code:"+509",code:"HT"},{name:"Honduras",dial_code:"+504",code:"HN"},{name:"Hungary",dial_code:"+36",code:"HU"},{name:"Iceland",dial_code:"+354",code:"IS"},{name:"India",dial_code:"+91",code:"IN"},{name:"Indonesia",dial_code:"+62",code:"ID"},{name:"Iraq",dial_code:"+964",code:"IQ"},{name:"Ireland",dial_code:"+353",code:"IE"},{name:"Israel",dial_code:"+972",code:"IL"},{name:"Italy",dial_code:"+39",code:"IT"},{name:"Jamaica",dial_code:"+1 876",code:"JM"},{name:"Japan",dial_code:"+81",code:"JP"},{name:"Jordan",dial_code:"+962",code:"JO"},{name:"Kazakhstan",dial_code:"+7 7",code:"KZ"},{name:"Kenya",dial_code:"+254",code:"KE"},{name:"Kiribati",dial_code:"+686",code:"KI"},{name:"Kuwait",dial_code:"+965",code:"KW"},{name:"Kyrgyzstan",dial_code:"+996",code:"KG"},{name:"Latvia",dial_code:"+371",code:"LV"},{name:"Lebanon",dial_code:"+961",code:"LB"},{name:"Lesotho",dial_code:"+266",code:"LS"},{name:"Liberia",dial_code:"+231",code:"LR"},{name:"Liechtenstein",dial_code:"+423",code:"LI"},{name:"Lithuania",dial_code:"+370",code:"LT"},{name:"Luxembourg",dial_code:"+352",code:"LU"},{name:"Madagascar",dial_code:"+261",code:"MG"},{name:"Malawi",dial_code:"+265",code:"MW"},{name:"Malaysia",dial_code:"+60",code:"MY"},{name:"Maldives",dial_code:"+960",code:"MV"},{name:"Mali",dial_code:"+223",code:"ML"},{name:"Malta",dial_code:"+356",code:"MT"},{name:"Marshall Islands",dial_code:"+692",code:"MH"},{name:"Martinique",dial_code:"+596",code:"MQ"},{name:"Mauritania",dial_code:"+222",code:"MR"},{name:"Mauritius",dial_code:"+230",code:"MU"},{name:"Mayotte",dial_code:"+262",code:"YT"},{name:"Mexico",dial_code:"+52",code:"MX"},{name:"Monaco",dial_code:"+377",code:"MC"},{name:"Mongolia",dial_code:"+976",code:"MN"},{name:"Montenegro",dial_code:"+382",code:"ME"},{name:"Montserrat",dial_code:"+1664",code:"MS"},{name:"Morocco",dial_code:"+212",code:"MA"},{name:"Myanmar",dial_code:"+95",code:"MM"},{name:"Namibia",dial_code:"+264",code:"NA"},{name:"Nauru",dial_code:"+674",code:"NR"},{name:"Nepal",dial_code:"+977",code:"NP"},{name:"Netherlands",dial_code:"+31",code:"NL"},{name:"Netherlands Antilles",dial_code:"+599",code:"AN"},{name:"New Caledonia",dial_code:"+687",code:"NC"},{name:"New Zealand",dial_code:"+64",code:"NZ"},{name:"Nicaragua",dial_code:"+505",code:"NI"},{name:"Niger",dial_code:"+227",code:"NE"},{name:"Nigeria",dial_code:"+234",code:"NG"},{name:"Niue",dial_code:"+683",code:"NU"},{name:"Norfolk Island",dial_code:"+672",code:"NF"},{name:"Northern Mariana Islands",dial_code:"+1 670",code:"MP"},{name:"Norway",dial_code:"+47",code:"NO"},{name:"Oman",dial_code:"+968",code:"OM"},{name:"Pakistan",dial_code:"+92",code:"PK"},{name:"Palau",dial_code:"+680",code:"PW"},{name:"Panama",dial_code:"+507",code:"PA"},{name:"Papua New Guinea",dial_code:"+675",code:"PG"},{name:"Paraguay",dial_code:"+595",code:"PY"},{name:"Peru",dial_code:"+51",code:"PE"},{name:"Philippines",dial_code:"+63",code:"PH"},{name:"Poland",dial_code:"+48",code:"PL"},{name:"Portugal",dial_code:"+351",code:"PT"},{name:"Puerto Rico",dial_code:"+1 939",code:"PR"},{name:"Qatar",dial_code:"+974",code:"QA"},{name:"Romania",dial_code:"+40",code:"RO"},{name:"Rwanda",dial_code:"+250",code:"RW"},{name:"Samoa",dial_code:"+685",code:"WS"},{name:"San Marino",dial_code:"+378",code:"SM"},{name:"Saudi Arabia",dial_code:"+966",code:"SA"},{name:"Senegal",dial_code:"+221",code:"SN"},{name:"Serbia",dial_code:"+381",code:"RS"},{name:"Seychelles",dial_code:"+248",code:"SC"},{name:"Sierra Leone",dial_code:"+232",code:"SL"},{name:"Singapore",dial_code:"+65",code:"SG"},{name:"Slovakia",dial_code:"+421",code:"SK"},{name:"Slovenia",dial_code:"+386",code:"SI"},{name:"Solomon Islands",dial_code:"+677",code:"SB"},{name:"South Africa",dial_code:"+27",code:"ZA"},{name:"South Georgia and the South Sandwich Islands",dial_code:"+500",code:"GS"},{name:"Spain",dial_code:"+34",code:"ES"},{name:"Sri Lanka",dial_code:"+94",code:"LK"},{name:"Sudan",dial_code:"+249",code:"SD"},{name:"Suriname",dial_code:"+597",code:"SR"},{name:"Swaziland",dial_code:"+268",code:"SZ"},{name:"Sweden",dial_code:"+46",code:"SE"},{name:"Switzerland",dial_code:"+41",code:"CH"},{name:"Tajikistan",dial_code:"+992",code:"TJ"},{name:"Thailand",dial_code:"+66",code:"TH"},{name:"Togo",dial_code:"+228",code:"TG"},{name:"Tokelau",dial_code:"+690",code:"TK"},{name:"Tonga",dial_code:"+676",code:"TO"},{name:"Trinidad and Tobago",dial_code:"+1 868",code:"TT"},{name:"Tunisia",dial_code:"+216",code:"TN"},{name:"Turkey",dial_code:"+90",code:"TR"},{name:"Turkmenistan",dial_code:"+993",code:"TM"},{name:"Turks and Caicos Islands",dial_code:"+1 649",code:"TC"},{name:"Tuvalu",dial_code:"+688",code:"TV"},{name:"Uganda",dial_code:"+256",code:"UG"},{name:"Ukraine",dial_code:"+380",code:"UA"},{name:"United Arab Emirates",dial_code:"+971",code:"AE"},{name:"United Kingdom",dial_code:"+44",code:"GB"},{name:"United States",dial_code:"+1",code:"US"},{name:"Uruguay",dial_code:"+598",code:"UY"},{name:"Uzbekistan",dial_code:"+998",code:"UZ"},{name:"Vanuatu",dial_code:"+678",code:"VU"},{name:"Wallis and Futuna",dial_code:"+681",code:"WF"},{name:"Yemen",dial_code:"+967",code:"YE"},{name:"Zambia",dial_code:"+260",code:"ZM"},{name:"Zimbabwe",dial_code:"+263",code:"ZW"},{name:"land Islands",dial_code:"",code:"AX"},{name:"Bolivia, Plurinational State of",dial_code:"+591",code:"BO"},{name:"Brunei Darussalam",dial_code:"+673",code:"BN"},{name:"Cocos (Keeling) Islands",dial_code:"+61",code:"CC"},{name:"Congo, The Democratic Republic of the",dial_code:"+243",code:"CD"},{name:"Cote d'Ivoire",dial_code:"+225",code:"CI"},{name:"Falkland Islands (Malvinas)",dial_code:"+500",code:"FK"},{name:"Guernsey",dial_code:"+44",code:"GG"},{name:"Holy See (Vatican City State)",dial_code:"+379",code:"VA"},{name:"Hong Kong",dial_code:"+852",code:"HK"},{name:"Iran, Islamic Republic of",dial_code:"+98",code:"IR"},{name:"Isle of Man",dial_code:"+44",code:"IM"},{name:"Jersey",dial_code:"+44",code:"JE"},{name:"Korea, Democratic People's Republic of",dial_code:"+850",code:"KP"},{name:"Korea, Republic of",dial_code:"+82",code:"KR"},{name:"Lao People's Democratic Republic",dial_code:"+856",code:"LA"},{name:"Libyan Arab Jamahiriya",dial_code:"+218",code:"LY"},{name:"Macao",dial_code:"+853",code:"MO"},{name:"Macedonia, The Former Yugoslav Republic of",dial_code:"+389",code:"MK"},{name:"Micronesia, Federated States of",dial_code:"+691",code:"FM"},{name:"Moldova, Republic of",dial_code:"+373",code:"MD"},{name:"Mozambique",dial_code:"+258",code:"MZ"},{name:"Palestinian Territory, Occupied",dial_code:"+970",code:"PS"},{name:"Pitcairn",dial_code:"+872",code:"PN"},{name:"R\xe9union",dial_code:"+262",code:"RE"},{name:"Russia",dial_code:"+7",code:"RU"},{name:"Saint Barth\xe9lemy",dial_code:"+590",code:"BL"},{name:"Saint Helena, Ascension and Tristan Da Cunha",dial_code:"+290",code:"SH"},{name:"Saint Kitts and Nevis",dial_code:"+1 869",code:"KN"},{name:"Saint Lucia",dial_code:"+1 758",code:"LC"},{name:"Saint Martin",dial_code:"+590",code:"MF"},{name:"Saint Pierre and Miquelon",dial_code:"+508",code:"PM"},{name:"Saint Vincent and the Grenadines",dial_code:"+1 784",code:"VC"},{name:"Sao Tome and Principe",dial_code:"+239",code:"ST"},{name:"Somalia",dial_code:"+252",code:"SO"},{name:"Svalbard and Jan Mayen",dial_code:"+47",code:"SJ"},{name:"Syrian Arab Republic",dial_code:"+963",code:"SY"},{name:"Taiwan, Province of China",dial_code:"+886",code:"TW"},{name:"Tanzania, United Republic of",dial_code:"+255",code:"TZ"},{name:"Timor-Leste",dial_code:"+670",code:"TL"},{name:"Venezuela, Bolivarian Republic of",dial_code:"+58",code:"VE"},{name:"Viet Nam",dial_code:"+84",code:"VN"},{name:"Virgin Islands, British",dial_code:"+1 284",code:"VG"},{name:"Virgin Islands, U.S.",dial_code:"+1 340",code:"VI"}];
   
    $scope.checkGrad = function(grad){
        $scope.fresh_grad = grad;
    }

    $scope.no_experience = false;
    $scope.checkExp = function(no_experience){
        $scope.no_experience = no_experience;
        $scope.page4 = [{}];
        $scope.display('');
        $ionicScrollDelegate.resize();
    }

    $scope.job_pref = true;
    $scope.jobPref = function(job_pref){
        $scope.job_pref = job_pref;
        $scope.page4.preferred_position = undefined;
    }

    $scope.checkPos = function(position){
        if(position == '1'){
            $scope.otherPos = true;
        }
        else{
            $scope.otherPos = false;
        }
    }

    $scope.checkVesselType = function(vessel_type){
        if(vessel_type == '1'){
            $scope.otherVessel = true;
        }
        else{
            $scope.otherVessel = false;
        }
    }

    $scope.positionList = function(){
        $scope.posSpinner = true;
        Sj.positionList().then(function(data){
            $scope.posSpinner = false;
            if(data == 'failed'){
                if(LocalStorage.get('posLocalList')){
                    $scope.positionItems = JSON.parse(LocalStorage.get('posLocalList'));
                    return;
                }
                else{
                    $scope.posReload = true;
                    return false;
                }
            }
            LocalStorage.set('posLocalList', JSON.stringify(data));
            $scope.positionItems = data;
        });
    }
    $scope.vesselTypeList = function(){
        $scope.vtypeSpinner = true;
        Sj.vesselTypeList().then(function(data){
            $scope.vtypeSpinner = false;
            if(data == 'failed'){
                if(LocalStorage.get('vtypeLocalList')){
                    $scope.vesselItems = JSON.parse(LocalStorage.get('vtypeLocalList'));
                    return
                }
                else{
                    $scope.vtypeReload = true;
                    return false; 
                }
            }
            LocalStorage.set('vtypeLocalList', JSON.stringify(data));
            $scope.vesselItems = data;
        });
    }

    $scope.reloadList = function(list){
        if(list == 'position'){
            $scope.positionList();
            $scope.posReload = false;
        }
        else if(list == 'vessel_type'){
            $scope.vesselTypeList();
            $scope.vtypeReload = false;
        }
    }

    $scope.positionList();
    $scope.vesselTypeList();


    $scope.display = function(button_event){
        if($scope.no_experience == false){
            Jobs.all('seaExperience').then(function(data){
                $scope.itemSize = Obj.size(data);
                $scope.seaExperiences = data;
                if(button_event == 'next-page') {
                    if($scope.itemSize<1){
                        Dialog.alert('Please Add at Least 1 Work Experience');
                        return false;
                    }
                    $ionicScrollDelegate.scrollTop();
                    $scope.activePage = 'page5';
                }
            });
        }
        else if($scope.no_experience == true){
            Jobs.all('landExperience').then(function(data){
                $scope.itemSize = Obj.size(data);
                $scope.landExperiences = data;
                if(button_event == 'next-page') {
                    console.log($scope.itemSize);
                    if($scope.itemSize<1){
                        Dialog.alert('Please Add at Least 1 Work Experience');
                        return false;
                    }
                    $ionicScrollDelegate.scrollTop();
                    $scope.activePage = 'page5';
                }
            });
        }
    }
    $scope.display('');
    $scope.page1 = [{}];
    $scope.page2 = [{}];
    $scope.page3 = [{}];
    $scope.page4 = [{}];
    $scope.page5 = [{}];

    $scope.page2.contact = "+63";

    $scope.numberCode = function(code){
        $scope.page2.contact = code;
    }

    $scope.editForm = false;
    $scope.fresh_grad = false;
    $scope.activePage = 'page1';

    $scope.checkEmail = function(email){
        $scope.emailSpinner = true;
        Sj.checkEmail(email).then(function(data){
            $scope.check_email_error = false;
            $scope.emailSpinner = false;
            if(Obj.size(data)==1){
                $scope.emailExists = true;
            }
            else{
                $scope.emailExists = false;
            }
        }, function(data){
            $scope.check_email_error = true;
            $scope.emailSpinner = false;
        });
    }

    $scope.calculateAge = function calculateAge(birthday) { 
        var ageDifMs = Date.now() - birthday.getTime();
        var ageDate = new Date(ageDifMs); 
        if(Math.abs(ageDate.getUTCFullYear() - 1970) < 18){
            $scope.notLegal = true;
        }
        else{
            $scope.notLegal = false;
        }
    }

    $scope.backPage = function(page){
        $scope.activePage = page;
        $ionicScrollDelegate.scrollTop();
    }
    $scope.nextPage = function(page, registerForm4, page4){
        if($scope.fresh_grad == false){
            /*console.log(Obj.size(page4));
            console.log(page4);*/
            if(Obj.size(page4) > 1){
                registerForm4.$submitted = true;
                $scope.submitPage4(registerForm4, page4, 'next-page');
            }
            else if($scope.itemSize<1){
                Dialog.alert('Please Add at Least 1 Work Experience');
                return false;
            }
            else {
                $ionicScrollDelegate.scrollTop();
                $scope.activePage = page;
            }
            /*if($scope.itemSize<1){
                Dialog.alert('Please Add at Least 1 Work Experience');
                return false;
            }*/
        }
        else {
             $ionicScrollDelegate.scrollTop();
                $scope.activePage = page;
        }
    }

    $scope.submitPage1 = function(registerForm1, page1){         
        if(registerForm1.$valid == false){
            Dialog.alert('Please fill out all fields completely');  
            return false;
        }
        if($scope.emailExists == true){
            Dialog.alert('Email is already registered. Please change your email');
            return false;
        }
        if(page1.password != page1.confirm){
            Dialog.alert('Passwords do not match');
            return false;
        }

        var data = {
            email:page1.email,
            password:page1.password,
        }

        LocalStorage.setObject('page1', data);
        $scope.activePage = 'page2';
    }

    $scope.submitPage2 = function(registerForm2, page2){
        if(registerForm2.$valid == false){
            Dialog.alert('Please fill out all fields completely');            
            return false;
        }
        if($scope.notLegal == true){
            Dialog.alert('Age encoded is not valid!');
            return false;
        }
        if(page2.contact == page2.nationality.dial_code){
            Dialog.alert('Please enter your contact number');
            return false;
        }
        var bday = $filter('date')(page2.bday, "yyyy-MM-dd");
        var data = {
            lname: page2.lname,
            fname: page2.fname,
            mname: page2.mname,
            bday: bday,
            gender: page2.gender,
            address: page2.address,
            nationality: page2.nationality.name,
            contact: page2.contact,
        }

        LocalStorage.setObject('page2', data);
        $scope.activePage = 'page3';
    }

    $scope.submitPage3 = function(registerForm3, page3){
        if(registerForm3.$valid == false){
            Dialog.alert('Please fill out all fields completely');            
            return false;
        }

        var passport_date = $filter('date')(page3.passport_date, "yyyy-MM-dd");
        var seaman_date = $filter('date')(page3.seaman_date, "yyyy-MM-dd");
        if(page3.visa_date != null){
            var visa_date = $filter('date')(page3.visa_date, "yyyy-MM-dd");
        }
        var data = {
            passport:page3.passport,
            passport_date:passport_date,
            seaman:page3.seaman,
            seaman_date:seaman_date,
            visa:page3.visa,
            visa_date:visa_date
        }

        LocalStorage.setObject('page3', data);
        $scope.activePage = 'page4';
    }

    $scope.submitPage4 = function(registerForm4, page4, button_event){
        if(registerForm4.$valid == false){
            Dialog.alert('Please fill out all fields completely');            
            return false;
        }
        // console.log(page4);
        if($scope.no_experience == false){
            var signon_date = $filter('date')(page4.signon_date, "yyyy-MM-dd");
            var signoff_date = $filter('date')(page4.signoff_date, "yyyy-MM-dd");

            var data = {
                position_id:page4.position.id,
                position:page4.position.name,
                other_position:page4.other_position,
                manning_agency:page4.manning_agency,
                vessel_name:page4.vessel_name,
                vessel_type_id:page4.vessel_type.id,
                vessel_type:page4.vessel_type.name,
                other_vessel_type:page4.other_vessel_type,
                grt:page4.grt,
                trade_route:page4.trade_route,
                signon_date:signon_date,
                signoff_date:signoff_date
            }
            if($scope.editForm === false){
                Jobs.addSeaExp(data);
                Toast.show('Sea Service Added', 1000, 'bottom');
                // Dialog.alert('Sea Service Added');
            }
            else if($scope.editForm === true){
                Jobs.updateSeaExp(data, page4.id);
                // Dialog.alert('Sea Service Updated');
                $scope.editForm = false;
                $scope.otherPos = false;
                $scope.otherVessel = false;
                Toast.show('Sea Service Updated', 1000, 'bottom');
            }
            registerForm4.$setPristine();
            $scope.page4 = [{}];
        }
        else if($scope.no_experience == true){
            var from_date = $filter('date')(page4.from_date, "yyyy-MM-dd");
            if(page4.to_date != null){
                var to_date = $filter('date')(page4.to_date, "yyyy-MM-dd");
            }
            var data = {
                land_position:page4.land_position,
                employer:page4.employer,
                work_site:page4.work_site,
                from_date:from_date,
                to_date:to_date
            }
            if($scope.editForm === false){
                Jobs.addLandExp(data);
                Toast.show('Land Experience Added', 1000, 'bottom');
                // Dialog.alert('Land Experience Added');
            }
            else if($scope.editForm === true){
                Jobs.updateLandExp(data, page4.id);
                Toast.show('Land Experience Updated', 1000, 'bottom');
                $scope.editForm = false;
                // Dialog.alert('Land Experience Updated');
            }
            registerForm4.$setPristine();
            $scope.page4 = [{}];
        }
        if(button_event == 'next-page') {
            $scope.display(button_event);   
        }
        else{
            $scope.display('');
        }
    }

    $scope.submitPage5 = function(registerForm5, page5){
        if(registerForm5.$valid == false){
            if (registerForm5.terms.$valid == false){
                Dialog.alert('Please check terms of use to proceed');
                return false          
            }
            Dialog.alert('Please fill out all fields completely');            
            return false;
        }

        if(page5.subscribe == undefined || page5.subscribe == false){
            var subscribe = 0;
        }
        else if(page5.subscribe == true){
            var subscribe = 1;
        }

        if($scope.job_pref == undefined || $scope.job_pref == false){
            var job_alert = 0;
        }
        else if($scope.job_pref == true){
            var job_alert = 1;
        }

        var page1 = LocalStorage.getObject('page1');
        var page2 = LocalStorage.getObject('page2');
        var page3 = LocalStorage.getObject('page3');

        if($scope.fresh_grad == true){
            var dataToSend = {
                email: page1.email,
                password: page1.password,
                lname: page2.lname,
                fname: page2.fname,
                mname: page2.mname,
                bday: page2.bday,
                gender: page2.gender,
                nationality: page2.nationality,
                address: page2.address,
                contact: page2.contact,
                passport:page3.passport,
                passport_date:page3.passport_date,
                seaman:page3.seaman,
                seaman_date:page3.seaman_date,
                visa:page3.visa,
                visa_date:page3.visa_date,
                job_alert:job_alert,
                subscribe:subscribe,
                preference:page5.preferred_position,
                fresh_grad:1,
            }
            Sj.submitRegistration(JSON.stringify(dataToSend)).then(function(data){
                if(data.success == "empty") {
                    Dialog.alert("Unable to submit your registration. Please try again.", "Registration Error");
                    return false;
                }
                var page = LocalStorage.getObject('page1');
                var user = {
                    email: page.email,
                    password: page.password
                }
                LocalStorage.remove('page1');
                LocalStorage.remove('page2');
                LocalStorage.remove('page3');
                Jobs.removeAll('seaExperience');
                Jobs.removeAll('landExperience');
                
                Sj.checkUser(user).then(function(data){  
                    LocalStorage.set('email', data[0].emailaddress);
                    LocalStorage.set('id', data[0].id);
                    LocalStorage.set('firstname', data[0].firstname);
                    $scope.activePage = 'page1';
                    $rootScope.$broadcast('authenticated', LocalStorage.get('firstname'));          
                    Dialog.alert('Thank you and Congratulations for signing up to SeamanJobsite.com! You may now apply to different maritime jobs available. Good luck!');
                    $state.go('home');
                });
            });
        }
        else{
            if($scope.no_experience == false){
                Jobs.all('seaExperience').then(function(data){
                    var dataToSend = {
                        email: page1.email,
                        password: page1.password,
                        lname: page2.lname,
                        fname: page2.fname,
                        mname: page2.mname,
                        bday: page2.bday,
                        gender: page2.gender,
                        nationality: page2.nationality,
                        address: page2.address,
                        contact: page2.contact,
                        passport:page3.passport,
                        passport_date:page3.passport_date,
                        seaman:page3.seaman,
                        seaman_date:page3.seaman_date,
                        visa:page3.visa,
                        visa_date:page3.visa_date,
                        job_alert:job_alert,
                        subscribe:subscribe,
                        preference:page5.preferred_position,
                        sea: data,
                        fresh_grad:0,
                        experience:'sea'
                    }
                    Sj.submitRegistration(JSON.stringify(dataToSend)).then(function(data){
                        if(data.success == "empty") {
                            Dialog.alert("Unable to submit your registration. Please try again.", "Registration Error");
                            return false;
                        }
                        var page = LocalStorage.getObject('page1');
                        var user = {
                            email: page.email,
                            password: page.password
                        }
                        LocalStorage.remove('page1');
                        LocalStorage.remove('page2');
                        LocalStorage.remove('page3');
                        Jobs.removeAll('seaExperience');
                        Jobs.removeAll('landExperience');
                        
                        Sj.checkUser(user).then(function(data){  
                            LocalStorage.set('email', data[0].emailaddress);
                            LocalStorage.set('id', data[0].id);
                            LocalStorage.set('firstname', data[0].firstname);
                            $scope.activePage = 'page1';
                            $rootScope.$broadcast('authenticated', LocalStorage.get('firstname'));          
                            Dialog.alert('Thank you and Congratulations for signing up to SeamanJobsite.com! You may now apply to different maritime jobs available. Good luck!');
                            $state.go('home');
                        });
                    });
                });
            }
            else if($scope.no_experience == true){
                Jobs.all('landExperience').then(function(data){   
                        var dataToSend = {
                        email: page1.email,
                        password: page1.password,
                        lname: page2.lname,
                        fname: page2.fname,
                        mname: page2.mname,
                        bday: page2.bday,
                        gender: page2.gender,
                        nationality: page2.nationality,
                        address: page2.address,
                        contact: page2.contact,
                        passport:page3.passport,
                        passport_date:page3.passport_date,
                        seaman:page3.seaman,
                        seaman_date:page3.seaman_date,
                        visa:page3.visa,
                        visa_date:page3.visa_date,
                        job_alert:job_alert,
                        subscribe:subscribe,
                        preference:page5.preferred_position,
                        land: data,
                        fresh_grad:0,
                        experience:'land'
                    }
                    Sj.submitRegistration(JSON.stringify(dataToSend)).then(function(data){
                        if(data.success == "empty") {
                            Dialog.alert("Unable to submit your registration. Please try again.", "Registration Error");
                            return false;
                        }
                        var page = LocalStorage.getObject('page1');
                        var user = {
                            email: page.email,
                            password: page.password
                        }
                        LocalStorage.remove('page1');
                        LocalStorage.remove('page2');
                        LocalStorage.remove('page3');
                        Jobs.removeAll('seaExperience');
                        Jobs.removeAll('landExperience');
                        
                        Sj.checkUser(user).then(function(data){  
                            LocalStorage.set('email', data[0].emailaddress);
                            LocalStorage.set('id', data[0].id);
                            LocalStorage.set('firstname', data[0].firstname);
                            $scope.activePage = 'page1';
                            $rootScope.$broadcast('authenticated', LocalStorage.get('firstname'));          
                            Dialog.alert('Thank you and Congratulations for signing up to SeamanJobsite.com! You may now apply to different maritime jobs available. Good luck!')
                            $state.go('home');
                        });
                    });
                });
            }
        }
        
    }

    $scope.openModal = function(){
        $rootScope.$broadcast('terms');
    }

    $scope.cancelEdit = function(form){
        form.$setPristine();
        $scope.page4 = [{}];
        $scope.editForm = false;
        $scope.otherPos = false;
        $scope.otherVessel = false;
    }

    $scope.editExp = function(table, id){
        $scope.editForm = true;
        Jobs.getExp(table, id).then(function(data){
            console.log(data);
            if(table == 'seaExperience'){
                $scope.posOptions = { id: data.position_id, name: data.position};
                var vesselOptions = { id: data.vessel_type_id, name: data.vessel_type};
                var signon_date = $filter("date")(data.signon_date, 'yyyy-MM-dd');
                var signoff_date = $filter("date")(data.signoff_date, 'yyyy-MM-dd');
                $scope.page4 = {
                    id:data.id,
                    position: $scope.posOptions,
                    other_position: data.other_position,
                    manning_agency: data.manning_agency,
                    vessel_name: data.vessel_name,
                    vessel_type: vesselOptions,
                    other_vessel_type: data.other_vessel_type,
                    grt: data.grt,
                    trade_route: data.trade_route,
                    signon_date: new Date(signon_date),
                    signoff_date: new Date(signoff_date)
                }
                if(data.position_id == '1'){
                    $scope.otherPos = true;
                }
                else{
                    $scope.otherPos = false;
                }

                if(data.vessel_type_id == '1'){
                    $scope.otherVessel = true;
                }
                else{
                    $scope.otherVessel = false;
                }
            }
            else if(table == 'landExperience'){
                var from_date = $filter("date")(data.from_date, 'yyyy-MM-dd');
                if(data.to_date == '0000-00-00' || data.to_date === null){
                    var to_date = ''
                }
                else{
                    var to_date = $filter('date')(data.to_date, "yyyy-MM-dd");
                }

                $scope.page4 = {
                    id:data.id,
                    land_position: data.land_position,
                    employer: data.employer,
                    work_site: data.work_site,
                    from_date: new Date(from_date),
                    to_date: new Date(to_date),
                }
            }
        });
    }

    $scope.deleteExp = function(table, field, value){
        Dialog.confirm('Delete Experience', 'Delete Work Experience?', function(res){ 
            if(res ==1){
                Jobs.remove(table, field, value);
                $scope.display('');
            }
        });
    }

})

.controller('HomeController', function($scope, $state, $rootScope, Sj, Dialog, LocalStorage) {
 	$scope.searchTypes = [{
        value: 'Jobs',
        label: 'Jobs',
    }, {
        value: 'Agency',
        label: 'Agency'
    }];  

    // $scope.selectedsearchType = ''; 
    
    $scope.selected = function(selectedValue){
        $scope.selectedUserType = selectedValue; 
    }

    $scope.jobSearch = function(search){
        var search = angular.copy(search);
        if(search !== undefined){
            if(search.input === undefined || search.input == ''){
                Dialog.alert('Please Enter Rank/Vessel or Agency', 'Search Failed');
                return false;
            }
            if(search.type === undefined || search.type === null){
                Dialog.alert('Please Choose Search Type', 'Search Failed');
                return false;
            }
            $state.go('jobs', { what: search.input, search_by:search.type});
        }
        else{
             Dialog.alert('Please Enter Rank/Vessel or Agency', 'Search Failed');
        }
    }

    $scope.$on('homeAuth', function (event, args) {
        // console.log('test');
        if(!LocalStorage.get('email')){
            $scope.loggedIn = false;
        }
        else{
            $scope.loggedIn = true;
        }
    });

    if(!LocalStorage.get('email')){
        $scope.loggedIn = false;
    }
    else{
        $scope.loggedIn = true;
    }
})

.controller('ProfileController', function($scope, $state, $filter, $ionicLoading, Sj, Obj, Dialog, Toast, LocalStorage) {
    $scope.list = function(){    
        $ionicLoading.show({showBackdrop: true,});
        Sj.checkEmail(LocalStorage.get('email')).then(function(data){
            $scope.item = data[0];
            $scope.birthday = $filter('date')($scope.item.birthdate, "MMM dd, yyyy");
            $scope.passport_valid = $filter('date')($scope.item.passport_valid, "MMM dd, yyyy");
            $scope.seaman_valid = $filter('date')($scope.item.seaman_valid, "MMM dd, yyyy");
            // $scope.signon = $filter('date')($scope.item.lastsignon, "MMM dd, yyyy");
            // $scope.signoff = $filter('date')($scope.item.lastsignoff, "MMM dd, yyyy");
            // $scope.datefrom = $filter('date')($scope.item.empdatefrom, "MMM dd, yyyy");

            LocalStorage.set('lastname', data[0].lastname);
            LocalStorage.set('firstname', data[0].firstname);
            LocalStorage.set('middlename', data[0].middlename);

            if($scope.item.visa_valid  != null){
                $scope.visa_valid = $filter('date')($scope.item.visa_valid, "MMM dd, yyyy");
            }
            // if($scope.item.empdateto == null || $scope.item.empdateto == '0000-00-00'){
            //     $scope.dateto = "Present";
            // }
            // else{
            //     $scope.dateto = $filter('date')($scope.item.empdateto, "MMM dd, yyyy");
            // }

            if($scope.item.sex == "M"){
                $scope.sex = "Male";
            }
            else if($scope.item.sex == "F"){
                $scope.sex = "Female"
            }

            Sj.getSeaEmployment(LocalStorage.get('id')).then(function(data){
                $scope.seaItemSize = Obj.size(data);
                $scope.seaItems = data;
            })
            Sj.getLandEmployment(LocalStorage.get('id')).then(function(data){
                $scope.landItemSize = Obj.size(data);
                $scope.landItems = data;
                $ionicLoading.hide();
            })
        });
    }

    $scope.list();

    $scope.deleteExp = function(id, form){
        Dialog.confirm('Remove Experience', 'Remove this Work Experience?', function(res){ 
            if(res ==1) 
            {
                Sj.deleteExp(id,form).then(function(data){
                    $scope.list();
                    Toast.show('Work Experience Deleted', 1500, 'bottom');
                    // Dialog.alert('Work Experience Deleted');
                });   
            }
        });
    }
})

.controller('LoginDetailsController', function($scope, $state, $filter, $ionicLoading, Sj, Dialog, LocalStorage) {
    $ionicLoading.show({showBackdrop: true,});
    Sj.checkEmail(LocalStorage.get('email')).then(function(data){
        $scope.item = data[0];
        $ionicLoading.hide();
    });
})

.controller('EditController', function($scope, $state, $stateParams, $filter, $ionicLoading, $ionicModal, $rootScope, Sj, Obj, Dialog, LocalStorage, Toast){
    $scope.editForm = $stateParams.form;
    $scope.user = [{}];
    $scope.sea = [{}];
    $scope.land = [{}];

    $scope.positionList = function(){
        $scope.posSpinner = true;
        Sj.positionList().then(function(data){
            $scope.posSpinner = false;
            if(data == 'failed'){
                if(LocalStorage.get('posLocalList')){
                    $scope.positionItems = JSON.parse(LocalStorage.get('posLocalList'));
                    return;
                }
                else{
                    $scope.posReload = true;
                    return false;
                }
            }
            LocalStorage.set('posLocalList', JSON.stringify(data));
            $scope.positionItems = data;
        });
    }
    $scope.vesselTypeList = function(){
        $scope.vtypeSpinner = true;
        Sj.vesselTypeList().then(function(data){
            $scope.vtypeSpinner = false;
            if(data == 'failed'){
                if(LocalStorage.get('vtypeLocalList')){
                    $scope.vesselItems = JSON.parse(LocalStorage.get('vtypeLocalList'));
                    return
                }
                else{
                    $scope.vtypeReload = true;
                    return false; 
                }
            }
            LocalStorage.set('vtypeLocalList', JSON.stringify(data));
            $scope.vesselItems = data;
        });
    }

    $scope.reloadList = function(list){
        if(list == 'position'){
            $scope.positionList();
            $scope.posReload = false;
        }
        else if(list == 'vessel_type'){
            $scope.vesselTypeList();
            $scope.vtypeReload = false;
        }
    }

    $scope.checkPos = function(position){
        if(position == '1'){
            $scope.otherPos = true;
        }
        else{
            $scope.otherPos = false;
        }
    }

    $scope.checkVesselType = function(vessel_type){
        if(vessel_type == '1'){
            $scope.otherVessel = true;
        }
        else{
            $scope.otherVessel = false;
        }
    }

    $ionicModal.fromTemplateUrl('edit-resume.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });
      $scope.closeModal = function() {
        $scope.modal.hide();
      };
      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });

    $scope.numberCode = function(code){
        $scope.user.contact = code;
    }

    $ionicLoading.show({showBackdrop: true,});
    if($stateParams.form == 'personal'){
        $scope.countries=[{name:"Afghanistan",dial_code:"+93",code:"AF"},{name:"Albania",dial_code:"+355",code:"AL"},{name:"Algeria",dial_code:"+213",code:"DZ"},{name:"AmericanSamoa",dial_code:"+1 684",code:"AS"},{name:"Andorra",dial_code:"+376",code:"AD"},{name:"Angola",dial_code:"+244",code:"AO"},{name:"Anguilla",dial_code:"+1 264",code:"AI"},{name:"Antigua and Barbuda",dial_code:"+1268",code:"AG"},{name:"Argentina",dial_code:"+54",code:"AR"},{name:"Armenia",dial_code:"+374",code:"AM"},{name:"Aruba",dial_code:"+297",code:"AW"},{name:"Australia",dial_code:"+61",code:"AU"},{name:"Austria",dial_code:"+43",code:"AT"},{name:"Azerbaijan",dial_code:"+994",code:"AZ"},{name:"Bahamas",dial_code:"+1 242",code:"BS"},{name:"Bahrain",dial_code:"+973",code:"BH"},{name:"Bangladesh",dial_code:"+880",code:"BD"},{name:"Barbados",dial_code:"+1 246",code:"BB"},{name:"Belarus",dial_code:"+375",code:"BY"},{name:"Belgium",dial_code:"+32",code:"BE"},{name:"Belize",dial_code:"+501",code:"BZ"},{name:"Benin",dial_code:"+229",code:"BJ"},{name:"Bermuda",dial_code:"+1 441",code:"BM"},{name:"Bhutan",dial_code:"+975",code:"BT"},{name:"Bosnia and Herzegovina",dial_code:"+387",code:"BA"},{name:"Botswana",dial_code:"+267",code:"BW"},{name:"Brazil",dial_code:"+55",code:"BR"},{name:"British Indian Ocean Territory",dial_code:"+246",code:"IO"},{name:"Bulgaria",dial_code:"+359",code:"BG"},{name:"Burkina Faso",dial_code:"+226",code:"BF"},{name:"Burundi",dial_code:"+257",code:"BI"},{name:"Cambodia",dial_code:"+855",code:"KH"},{name:"Cameroon",dial_code:"+237",code:"CM"},{name:"Canada",dial_code:"+1",code:"CA"},{name:"Cape Verde",dial_code:"+238",code:"CV"},{name:"Cayman Islands",dial_code:"+ 345",code:"KY"},{name:"Central African Republic",dial_code:"+236",code:"CF"},{name:"Chad",dial_code:"+235",code:"TD"},{name:"Chile",dial_code:"+56",code:"CL"},{name:"China",dial_code:"+86",code:"CN"},{name:"Christmas Island",dial_code:"+61",code:"CX"},{name:"Colombia",dial_code:"+57",code:"CO"},{name:"Comoros",dial_code:"+269",code:"KM"},{name:"Congo",dial_code:"+242",code:"CG"},{name:"Cook Islands",dial_code:"+682",code:"CK"},{name:"Costa Rica",dial_code:"+506",code:"CR"},{name:"Croatia",dial_code:"+385",code:"HR"},{name:"Cuba",dial_code:"+53",code:"CU"},{name:"Cyprus",dial_code:"+537",code:"CY"},{name:"Czech Republic",dial_code:"+420",code:"CZ"},{name:"Denmark",dial_code:"+45",code:"DK"},{name:"Djibouti",dial_code:"+253",code:"DJ"},{name:"Dominica",dial_code:"+1 767",code:"DM"},{name:"Dominican Republic",dial_code:"+1 849",code:"DO"},{name:"Ecuador",dial_code:"+593",code:"EC"},{name:"Egypt",dial_code:"+20",code:"EG"},{name:"El Salvador",dial_code:"+503",code:"SV"},{name:"Equatorial Guinea",dial_code:"+240",code:"GQ"},{name:"Eritrea",dial_code:"+291",code:"ER"},{name:"Estonia",dial_code:"+372",code:"EE"},{name:"Ethiopia",dial_code:"+251",code:"ET"},{name:"Faroe Islands",dial_code:"+298",code:"FO"},{name:"Fiji",dial_code:"+679",code:"FJ"},{name:"Finland",dial_code:"+358",code:"FI"},{name:"France",dial_code:"+33",code:"FR"},{name:"French Guiana",dial_code:"+594",code:"GF"},{name:"French Polynesia",dial_code:"+689",code:"PF"},{name:"Gabon",dial_code:"+241",code:"GA"},{name:"Gambia",dial_code:"+220",code:"GM"},{name:"Georgia",dial_code:"+995",code:"GE"},{name:"Germany",dial_code:"+49",code:"DE"},{name:"Ghana",dial_code:"+233",code:"GH"},{name:"Gibraltar",dial_code:"+350",code:"GI"},{name:"Greece",dial_code:"+30",code:"GR"},{name:"Greenland",dial_code:"+299",code:"GL"},{name:"Grenada",dial_code:"+1 473",code:"GD"},{name:"Guadeloupe",dial_code:"+590",code:"GP"},{name:"Guam",dial_code:"+1 671",code:"GU"},{name:"Guatemala",dial_code:"+502",code:"GT"},{name:"Guinea",dial_code:"+224",code:"GN"},{name:"Guinea-Bissau",dial_code:"+245",code:"GW"},{name:"Guyana",dial_code:"+595",code:"GY"},{name:"Haiti",dial_code:"+509",code:"HT"},{name:"Honduras",dial_code:"+504",code:"HN"},{name:"Hungary",dial_code:"+36",code:"HU"},{name:"Iceland",dial_code:"+354",code:"IS"},{name:"India",dial_code:"+91",code:"IN"},{name:"Indonesia",dial_code:"+62",code:"ID"},{name:"Iraq",dial_code:"+964",code:"IQ"},{name:"Ireland",dial_code:"+353",code:"IE"},{name:"Israel",dial_code:"+972",code:"IL"},{name:"Italy",dial_code:"+39",code:"IT"},{name:"Jamaica",dial_code:"+1 876",code:"JM"},{name:"Japan",dial_code:"+81",code:"JP"},{name:"Jordan",dial_code:"+962",code:"JO"},{name:"Kazakhstan",dial_code:"+7 7",code:"KZ"},{name:"Kenya",dial_code:"+254",code:"KE"},{name:"Kiribati",dial_code:"+686",code:"KI"},{name:"Kuwait",dial_code:"+965",code:"KW"},{name:"Kyrgyzstan",dial_code:"+996",code:"KG"},{name:"Latvia",dial_code:"+371",code:"LV"},{name:"Lebanon",dial_code:"+961",code:"LB"},{name:"Lesotho",dial_code:"+266",code:"LS"},{name:"Liberia",dial_code:"+231",code:"LR"},{name:"Liechtenstein",dial_code:"+423",code:"LI"},{name:"Lithuania",dial_code:"+370",code:"LT"},{name:"Luxembourg",dial_code:"+352",code:"LU"},{name:"Madagascar",dial_code:"+261",code:"MG"},{name:"Malawi",dial_code:"+265",code:"MW"},{name:"Malaysia",dial_code:"+60",code:"MY"},{name:"Maldives",dial_code:"+960",code:"MV"},{name:"Mali",dial_code:"+223",code:"ML"},{name:"Malta",dial_code:"+356",code:"MT"},{name:"Marshall Islands",dial_code:"+692",code:"MH"},{name:"Martinique",dial_code:"+596",code:"MQ"},{name:"Mauritania",dial_code:"+222",code:"MR"},{name:"Mauritius",dial_code:"+230",code:"MU"},{name:"Mayotte",dial_code:"+262",code:"YT"},{name:"Mexico",dial_code:"+52",code:"MX"},{name:"Monaco",dial_code:"+377",code:"MC"},{name:"Mongolia",dial_code:"+976",code:"MN"},{name:"Montenegro",dial_code:"+382",code:"ME"},{name:"Montserrat",dial_code:"+1664",code:"MS"},{name:"Morocco",dial_code:"+212",code:"MA"},{name:"Myanmar",dial_code:"+95",code:"MM"},{name:"Namibia",dial_code:"+264",code:"NA"},{name:"Nauru",dial_code:"+674",code:"NR"},{name:"Nepal",dial_code:"+977",code:"NP"},{name:"Netherlands",dial_code:"+31",code:"NL"},{name:"Netherlands Antilles",dial_code:"+599",code:"AN"},{name:"New Caledonia",dial_code:"+687",code:"NC"},{name:"New Zealand",dial_code:"+64",code:"NZ"},{name:"Nicaragua",dial_code:"+505",code:"NI"},{name:"Niger",dial_code:"+227",code:"NE"},{name:"Nigeria",dial_code:"+234",code:"NG"},{name:"Niue",dial_code:"+683",code:"NU"},{name:"Norfolk Island",dial_code:"+672",code:"NF"},{name:"Northern Mariana Islands",dial_code:"+1 670",code:"MP"},{name:"Norway",dial_code:"+47",code:"NO"},{name:"Oman",dial_code:"+968",code:"OM"},{name:"Pakistan",dial_code:"+92",code:"PK"},{name:"Palau",dial_code:"+680",code:"PW"},{name:"Panama",dial_code:"+507",code:"PA"},{name:"Papua New Guinea",dial_code:"+675",code:"PG"},{name:"Paraguay",dial_code:"+595",code:"PY"},{name:"Peru",dial_code:"+51",code:"PE"},{name:"Philippines",dial_code:"+63",code:"PH"},{name:"Poland",dial_code:"+48",code:"PL"},{name:"Portugal",dial_code:"+351",code:"PT"},{name:"Puerto Rico",dial_code:"+1 939",code:"PR"},{name:"Qatar",dial_code:"+974",code:"QA"},{name:"Romania",dial_code:"+40",code:"RO"},{name:"Rwanda",dial_code:"+250",code:"RW"},{name:"Samoa",dial_code:"+685",code:"WS"},{name:"San Marino",dial_code:"+378",code:"SM"},{name:"Saudi Arabia",dial_code:"+966",code:"SA"},{name:"Senegal",dial_code:"+221",code:"SN"},{name:"Serbia",dial_code:"+381",code:"RS"},{name:"Seychelles",dial_code:"+248",code:"SC"},{name:"Sierra Leone",dial_code:"+232",code:"SL"},{name:"Singapore",dial_code:"+65",code:"SG"},{name:"Slovakia",dial_code:"+421",code:"SK"},{name:"Slovenia",dial_code:"+386",code:"SI"},{name:"Solomon Islands",dial_code:"+677",code:"SB"},{name:"South Africa",dial_code:"+27",code:"ZA"},{name:"South Georgia and the South Sandwich Islands",dial_code:"+500",code:"GS"},{name:"Spain",dial_code:"+34",code:"ES"},{name:"Sri Lanka",dial_code:"+94",code:"LK"},{name:"Sudan",dial_code:"+249",code:"SD"},{name:"Suriname",dial_code:"+597",code:"SR"},{name:"Swaziland",dial_code:"+268",code:"SZ"},{name:"Sweden",dial_code:"+46",code:"SE"},{name:"Switzerland",dial_code:"+41",code:"CH"},{name:"Tajikistan",dial_code:"+992",code:"TJ"},{name:"Thailand",dial_code:"+66",code:"TH"},{name:"Togo",dial_code:"+228",code:"TG"},{name:"Tokelau",dial_code:"+690",code:"TK"},{name:"Tonga",dial_code:"+676",code:"TO"},{name:"Trinidad and Tobago",dial_code:"+1 868",code:"TT"},{name:"Tunisia",dial_code:"+216",code:"TN"},{name:"Turkey",dial_code:"+90",code:"TR"},{name:"Turkmenistan",dial_code:"+993",code:"TM"},{name:"Turks and Caicos Islands",dial_code:"+1 649",code:"TC"},{name:"Tuvalu",dial_code:"+688",code:"TV"},{name:"Uganda",dial_code:"+256",code:"UG"},{name:"Ukraine",dial_code:"+380",code:"UA"},{name:"United Arab Emirates",dial_code:"+971",code:"AE"},{name:"United Kingdom",dial_code:"+44",code:"GB"},{name:"United States",dial_code:"+1",code:"US"},{name:"Uruguay",dial_code:"+598",code:"UY"},{name:"Uzbekistan",dial_code:"+998",code:"UZ"},{name:"Vanuatu",dial_code:"+678",code:"VU"},{name:"Wallis and Futuna",dial_code:"+681",code:"WF"},{name:"Yemen",dial_code:"+967",code:"YE"},{name:"Zambia",dial_code:"+260",code:"ZM"},{name:"Zimbabwe",dial_code:"+263",code:"ZW"},{name:"land Islands",dial_code:"",code:"AX"},{name:"Bolivia, Plurinational State of",dial_code:"+591",code:"BO"},{name:"Brunei Darussalam",dial_code:"+673",code:"BN"},{name:"Cocos (Keeling) Islands",dial_code:"+61",code:"CC"},{name:"Congo, The Democratic Republic of the",dial_code:"+243",code:"CD"},{name:"Cote d'Ivoire",dial_code:"+225",code:"CI"},{name:"Falkland Islands (Malvinas)",dial_code:"+500",code:"FK"},{name:"Guernsey",dial_code:"+44",code:"GG"},{name:"Holy See (Vatican City State)",dial_code:"+379",code:"VA"},{name:"Hong Kong",dial_code:"+852",code:"HK"},{name:"Iran, Islamic Republic of",dial_code:"+98",code:"IR"},{name:"Isle of Man",dial_code:"+44",code:"IM"},{name:"Jersey",dial_code:"+44",code:"JE"},{name:"Korea, Democratic People's Republic of",dial_code:"+850",code:"KP"},{name:"Korea, Republic of",dial_code:"+82",code:"KR"},{name:"Lao People's Democratic Republic",dial_code:"+856",code:"LA"},{name:"Libyan Arab Jamahiriya",dial_code:"+218",code:"LY"},{name:"Macao",dial_code:"+853",code:"MO"},{name:"Macedonia, The Former Yugoslav Republic of",dial_code:"+389",code:"MK"},{name:"Micronesia, Federated States of",dial_code:"+691",code:"FM"},{name:"Moldova, Republic of",dial_code:"+373",code:"MD"},{name:"Mozambique",dial_code:"+258",code:"MZ"},{name:"Palestinian Territory, Occupied",dial_code:"+970",code:"PS"},{name:"Pitcairn",dial_code:"+872",code:"PN"},{name:"R\xe9union",dial_code:"+262",code:"RE"},{name:"Russia",dial_code:"+7",code:"RU"},{name:"Saint Barth\xe9lemy",dial_code:"+590",code:"BL"},{name:"Saint Helena, Ascension and Tristan Da Cunha",dial_code:"+290",code:"SH"},{name:"Saint Kitts and Nevis",dial_code:"+1 869",code:"KN"},{name:"Saint Lucia",dial_code:"+1 758",code:"LC"},{name:"Saint Martin",dial_code:"+590",code:"MF"},{name:"Saint Pierre and Miquelon",dial_code:"+508",code:"PM"},{name:"Saint Vincent and the Grenadines",dial_code:"+1 784",code:"VC"},{name:"Sao Tome and Principe",dial_code:"+239",code:"ST"},{name:"Somalia",dial_code:"+252",code:"SO"},{name:"Svalbard and Jan Mayen",dial_code:"+47",code:"SJ"},{name:"Syrian Arab Republic",dial_code:"+963",code:"SY"},{name:"Taiwan, Province of China",dial_code:"+886",code:"TW"},{name:"Tanzania, United Republic of",dial_code:"+255",code:"TZ"},{name:"Timor-Leste",dial_code:"+670",code:"TL"},{name:"Venezuela, Bolivarian Republic of",dial_code:"+58",code:"VE"},{name:"Viet Nam",dial_code:"+84",code:"VN"},{name:"Virgin Islands, British",dial_code:"+1 284",code:"VG"},{name:"Virgin Islands, U.S.",dial_code:"+1 340",code:"VI"}];

        Sj.checkEmail(LocalStorage.get('email')).then(function(data){
            if(data[0].sex == "M"){
                var sex= "Male";
            }
            else if(data[0].sex == "F"){
                var sex = "Female"
            }
            var bdate = $filter("date")(data[0].birthdate, 'yyyy-MM-dd');
            var passport_date = $filter("date")(data[0].passport_valid, 'yyyy-MM-dd');
            var seaman_date = $filter("date")(data[0].seaman_valid, 'yyyy-MM-dd');
            if(data[0].visa_valid != '0000-00-00'){
                var visa_date = $filter('date')(data[0].visa_valid, "yyyy-MM-dd");
            }
            else{
                var visa_date = '';
            }
            var nationality_options = { name: data[0].nationality, dial_code: '', code: ''};
            $scope.user = {
                lname:data[0].lastname,
                fname:data[0].firstname,
                mname:data[0].middlename,
                bday:new Date(bdate),
                gender:sex,
                nationality:nationality_options,
                address:data[0].address,
                contact:data[0].mobileno,
                passport:data[0].passport,
                passport_date:new Date(passport_date),
                seaman:data[0].seaman_book,
                seaman_date:new Date(seaman_date),
                visa:data[0].visa,
                visa_date:new Date(visa_date)
            };
        });
    }
    else if($stateParams.form == 'login'){  
        Sj.checkEmail(LocalStorage.get('email')).then(function(data){   
            $scope.login = [{}];
            $scope.login.email = data[0].emailaddress;
        });
    }
    else if($stateParams.form == 'sea'){
        Sj.getSeaDetails($stateParams.id).then(function(data){
            Sj.positionList().then(function(data){
                $scope.positionItems = data;
            });
            Sj.vesselTypeList().then(function(data){
                $scope.vesselItems = data;
            });

            var posOptions = { id: data[0].position_id, name: data[0].position};
            var vesselOptions = { id: data[0].vessel_type_id, name: data[0].vessel_type};
            var signon = $filter("date")(data[0].last_signon, 'yyyy-MM-dd');
            var signoff = $filter("date")(data[0].last_signoff, 'yyyy-MM-dd');
            LocalStorage.set('emp1id', data[0].id);
            $scope.sea = {
                last_rank:data[0].last_rank,
                position:posOptions,
                other_position: data[0].other_position,
                manning_agency:data[0].last_agency,
                vessel_name:data[0].last_vessel,
                vessel_type:vesselOptions,
                other_vessel_type: data[0].other_vessel_type,
                grt:data[0].last_grt,
                trade_route:data[0].last_trade_route,
                signon_date:new Date(signon),
                signoff_date:new Date(signoff)
            };
            if(data[0].position_id == '1'){
                $scope.otherPos = true;
            }
            else{
                $scope.otherPos = false;
            }

            if(data[0].vessel_type_id == '1'){
                $scope.otherVessel = true;
            }
            else{
                $scope.otherVessel = false;
            }

            if(data[0].position_id == '0' || data[0].vessel_type_id == '0'){
                var middle = LocalStorage.get('middlename').substring(0,1)+".";
                $scope.applicant = {
                    firstname: LocalStorage.get('firstname'),
                    middle: middle,
                    lastname: LocalStorage.get('lastname')
                }
                $scope.modal.show();
            }
        });
    }
    else if($stateParams.form == 'sea-add'){       
        $scope.positionList();
        $scope.vesselTypeList();
    }
    else if($stateParams.form == 'land'){
        Sj.getLandDetails($stateParams.id).then(function(data){
            var from_date = $filter("date")(data[0].datefrom, 'yyyy-MM-dd');
            if(data[0].dateto == '0000-00-00' || data[0].dateto === null){
                var to_date = ''
            }
            else{
                var to_date = $filter('date')(data[0].dateto, "yyyy-MM-dd");
            }
            LocalStorage.set('emp2id', data[0].id);
            $scope.land = {
                land_position:data[0].position,
                employer:data[0].company,
                work_site:data[0].work_site,
                from_date:new Date(from_date),
                to_date:new Date(to_date)
            }
        });
    }
    $ionicLoading.hide();

    $scope.updatePersonal = function(form, data){
         if(form.$valid == false){
            Dialog.alert('Please fill out all fields completely'); 
            return false;
        }
        if($scope.notLegal == true){
            Dialog.alert('Age encoded is not valid!');
            return false;
        }
        var applicant_id = LocalStorage.get('id');
        var bday = $filter('date')(data.bday, "yyyy-MM-dd");
        var passport_date = $filter('date')(data.passport_date, "yyyy-MM-dd");
        var seaman_date = $filter('date')(data.seaman_date, "yyyy-MM-dd");
        if(data.visa_date != null){
            var visa_date = $filter('date')(data.visa_date, "yyyy-MM-dd");
        }

        var dataToSend = {
            applicant_id:applicant_id,
            lname:data.lname,
            fname:data.fname,
            mname:data.mname,
            bday:bday,
            gender:data.gender,
            nationality:data.nationality.name,
            address:data.address,
            contact:data.contact,
            passport:data.passport,
            passport_date:passport_date,
            seaman:data.seaman,
            seaman_date:seaman_date,
            visa:data.visa,
            visa_date:visa_date,
            form:'personal'
        }

        console.log(dataToSend);
        Sj.updateProfile(JSON.stringify(dataToSend)).then(function(data){
            console.log(data);
            LocalStorage.set('firstname', dataToSend.fname);
            $rootScope.$broadcast('authenticated', LocalStorage.get('firstname'));
            // Dialog.alert('Personal Information Updated');
            Toast.show('Personal Information Updated', 1000, 'bottom');
            $state.go('profile');
        });
    }

    $scope.updateSea = function(form, data){
        if(form.$valid == false){
            Dialog.alert('Please fill out all fields completely'); 
            return false;
        }
        var applicant_id = LocalStorage.get('id');
        var emp1id = LocalStorage.get('emp1id');
        var signon = $filter("date")(data.signon_date, 'yyyy-MM-dd');
        var signoff = $filter("date")(data.signoff_date, 'yyyy-MM-dd');
        if($scope.editForm == 'sea'){
            var dataToSend = {
                applicant_id:applicant_id,
                emp1id: emp1id,
                position_id:data.position.id,
                other_position:data.other_position,
                manning_agency:data.manning_agency,
                vessel_name:data.vessel_name,
                vessel_type_id:data.vessel_type.id,
                other_vessel_type:data.other_vessel_type,
                vessel_type:data.vessel_type.name,
                grt:data.grt,
                trade_route:data.trade_route,
                signon_date:signon,
                signoff_date:signoff,
                form:'sea'
            };
            Sj.updateProfile(JSON.stringify(dataToSend)).then(function(data){
                console.log(data);
                // Dialog.alert('Sea Service Updated');
                Toast.show('Sea Service Updated', 1000, 'bottom');
                $state.go('profile');
            });
        }
        else if($scope.editForm == 'sea-add'){
            var dataToSend = {
                applicant_id:applicant_id,
                position_id:data.position.id,
                other_position:data.other_position,
                manning_agency:data.manning_agency,
                vessel_name:data.vessel_name,
                vessel_type_id:data.vessel_type.id,
                other_vessel_type:data.other_vessel_type,
                grt:data.grt,
                trade_route:data.trade_route,
                signon_date:signon,
                signoff_date:signoff,
                form:'sea'
            };
            console.log(dataToSend);
            Sj.addExperience(JSON.stringify(dataToSend)).then(function(data){
                // Dialog.alert('Sea Service Added');
                Toast.show('Sea Service Added', 1000, 'bottom');
                $state.go('profile');
            });
        }
    }

    $scope.updateLand = function(form, data){
        if(form.$valid == false){
            Dialog.alert('Please fill out all fields completely'); 
            return false;
        }
        var applicant_id = LocalStorage.get('id');
        var from_date = $filter("date")(data.from_date, 'yyyy-MM-dd');
        if(data.to_date == '0000-00-00' || data.to_date === null){
            var to_date = ''
        }
        else{
            var to_date = $filter('date')(data.to_date, "yyyy-MM-dd");
        }
        var emp2id = LocalStorage.get('emp2id');
        if($scope.editForm == 'land'){
            var dataToSend = {
                applicant_id:applicant_id,
                emp2id: emp2id,
                land_position:data.land_position,
                employer:data.employer,
                work_site:data.work_site,
                from_date:from_date,
                to_date:to_date,
                form:'land'
            }
            Sj.updateProfile(JSON.stringify(dataToSend)).then(function(data){
                console.log(data);
                // Dialog.alert('Land Based Experience Updated');
                Toast.show('Land Based Experience Updated', 1000, 'bottom');
                $state.go('profile');
            });
        }
        else if ($scope.editForm == 'land-add'){
            var dataToSend = {
                applicant_id:applicant_id,
                land_position:data.land_position,
                employer:data.employer,
                work_site:data.work_site,
                from_date:from_date,
                to_date:to_date,
                form:'land'
            }
            console.log(dataToSend);
            Sj.addExperience(JSON.stringify(dataToSend)).then(function(data){
                // Dialog.alert('Land Based Experience Added');
                Toast.show('Land Based Experience Added', 1000, 'bottom');
                $state.go('profile');
            });
        }
    }

    $scope.updateLogin = function(form, data){
        if(form.$valid == false){
            Dialog.alert('Please fill out all fields completely'); 
            return false;
        }
        var applicant_id = LocalStorage.get('id');
        if($scope.emailExists == true){
            Dialog.alert('Email is already registered. Please change your email');
        return false;
        }
        if(data.password != data.confirm){
            Dialog.alert('Passwords do not match');
            return false;
        }
        var dataToSend = {
            applicant_id:applicant_id,
            email:data.email,
            password:data.password,
            form:'login'
        }
        Sj.updateProfile(JSON.stringify(dataToSend)).then(function(data){
            console.log(data);
            LocalStorage.set('email', dataToSend.email);
            // Dialog.alert('Login Details Updated');
            Toast.show('Login Details Updated', 1000, 'bottom');
            $state.go('home');
        });
    }

    $scope.checkEmail = function(email){
        $scope.emailSpinner = true;
        Sj.checkEmail(email).then(function(data){
            $scope.emailSpinner = false;
            if(Obj.size(data)==1){
                if(data[0].emailaddress == LocalStorage.get('email')){
                    $scope.emailExists = false;  
                    return false; 
                }
                $scope.emailExists = true;
            }
            else{
                $scope.emailExists = false;
            }
        });
    }

    $scope.calculateAge = function calculateAge(birthday) { // birthday is a date
        var ageDifMs = Date.now() - birthday.getTime();
        var ageDate = new Date(ageDifMs); 
        if(Math.abs(ageDate.getUTCFullYear() - 1970) < 18){
            $scope.notLegal = true;
        }
        else{
            $scope.notLegal = false;
        }
    }
})

.controller('JobsController', function($scope, $stateParams, $state, $ionicModal, $ionicLoading, Dialog, Obj, Sj) {
    $scope.search = $stateParams.what;
    $scope.searchBy = $stateParams.search_by;
    $scope.itemsToDisplay = 60; 
    $scope.items = [];

    $scope.list = function(what,search_by){
        Sj.getSearchResult(what,search_by).then(function(data){
          $scope.itemSize = Obj.size(data);
          $scope.items = data;
          if($scope.itemSize > 60){
            $scope.moreItem = true;
          }
        });
    }

    $scope.agencyJobList = function(agency_id){
        Sj.getAgencyJobs(agency_id).then(function(data){
          $scope.itemSize = Obj.size(data);
          $scope.items = data;
          if($scope.itemSize > 60){
            $scope.moreItem = true;
          }
        });
    }

    if($stateParams.agency_id){
        $scope.agencyJobList($stateParams.agency_id);
    }
    else{
        $scope.list($stateParams.what,$stateParams.search_by);
    }

    $scope.jobSearch = function(search,searchBy){
        if(search === undefined || search == ''){
            Dialog.alert('Please Enter Rank/Vessel or Agency', 'Search Failed');
            return false;
        }
        if(searchBy === undefined || searchBy === null){
            Dialog.alert('Please Choose Search Type', 'Search Failed');
            return false;
        }
        $scope.list(search,searchBy);
        $scope.itemsToDisplay = 60; 
    }

    $scope.showMore = function(){
        $ionicLoading.show({showBackdrop: false,});
        setTimeout(function () {
            if ($scope.itemSize > $scope.itemsToDisplay){
                $scope.itemsToDisplay += 60; 
                $ionicLoading.hide();
                return;
            }
            $ionicLoading.hide();
            $scope.moreItem = false;
        }, 1500);
    }

     $ionicModal.fromTemplateUrl('jobs.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });
      $scope.openModal = function(agency_id) {
        Sj.getAgency(agency_id).then(function(data){
            $scope.modalData = data[0];
            $scope.modal.show();
        });
      };
      $scope.closeModal = function() {
        $scope.modal.hide();
      };
      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });

})

.controller('JobDetailsController', function($scope, $stateParams, $state, $ionicHistory, Dialog, Obj, Sj, LocalStorage, Jobs) {
    $scope.details = function(){
        Sj.getJobDetails($stateParams.jobid).then(function(data){
            $scope.items = data;
        });
    }
    $scope.details();

    Jobs.get($stateParams.jobid).then(function(job){
        if(job !== null){
            console.log(job);
            $scope.jobSaved = true;
        }
    });

    $scope.save = function(item){
        $scope.jobSaved = true; 
        console.log(item);
        var job = {
            jobid: item.jobid,
            agency_id: $stateParams.agency_id,
            position_title: item.position_title,
            available_positions: item.available_positions,
            vessel_type: item.vessel_type,
            opening_date: item.opening_date,
            closing_date: item.closing_date,
            benefits: item.benefits,
            description: item.description,
            establishment_name: item.establishment_name,
            establishment_address: item.establishment_address,
            establishment_contact: item.establishment_contact,
            establishment_poea_no: item.establishment_poea_no
        }
        Jobs.add(job);
    }

    $scope.unsave = function(item){
        $scope.jobSaved = false; 
        console.log(item);
    }

    $scope.back = function(){
        $ionicHistory.goBack();
    }

    if($stateParams.success){
        $scope.showMsg = true;
    }

    $scope.closeMsg = function(){
        $scope.showMsg = false;
    }

    $scope.apply = function(){
        if(!LocalStorage.get('email')){
            $state.go('login-first', { error: '1', jobid: $stateParams.jobid, agency_id:$stateParams.agency_id});
            return false;
        }
        $state.go('apply', { jobid: $stateParams.jobid, agency_id:$stateParams.agency_id});
    }
})

.controller('applyController', function($scope, $stateParams, $state, $filter, $rootScope, $ionicHistory, Dialog, Obj, Sj, LocalStorage) {
    $scope.jobDetails = function(){
        Sj.getJobDetails($stateParams.jobid).then(function(data){
            $scope.item = data[0];
        });
    }
    $scope.jobDetails();
    var email = LocalStorage.get('email');
    Sj.checkEmail(email).then(function(data){
        $scope.personal = data[0];
    });

    Sj.checkApplied(LocalStorage.get('id'), $stateParams.jobid).then(function(data){
        if(Obj.size(data)>=1){
            $scope.applied = true;
            $scope.application_date = $filter('date')(data[0].applicationdate, "MMM dd, yy");
        }
        else{
            $scope.applied = false;
        }
    });

    $scope.back = function(){
        $ionicHistory.goBack();
    }

    $scope.apply = function(){
        var applicant_id = LocalStorage.get('id');
        var job_id = $stateParams.jobid;
        var agency_id = $stateParams.agency_id;

        var dataToSend = {
            applicant_id:applicant_id,
            job_id:job_id,
            agency_id:agency_id
        }

        Sj.applyJob(JSON.stringify(dataToSend)).then(function(data){
            $rootScope.$broadcast('showMsg', 'true');
            $ionicHistory.goBack();
            if($stateParams.saved){
                $state.go('saved-job-details', { jobid: job_id, agency_id:agency_id, success:'true'});
            }
            else{
                $state.go('job-details', { jobid: job_id, agency_id:agency_id, success:'true'});
            }
        });

    }      
})

.controller('SavedJobsController', function($scope, $state, $ionicModal, Dialog, Obj, Sj, Jobs) {
    $scope.items = [];
    $scope.list = function(){
        Jobs.all('savedJobs').then(function(data){
            $scope.itemSize = Obj.size(data);
            $scope.items = data;
        });
    }
    $scope.list();

    $scope.removeJob = function(jobId){
        Dialog.confirm('Delete Job', 'Delete this Job From Saved Jobs?', function(res){ 
            if(res ==1) 
            {
                Jobs.remove('savedJobs', 'jobid', jobId);
                $scope.list();
            }
        });
    }

    $ionicModal.fromTemplateUrl('saved-jobs.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });
      $scope.openModal = function(agency_id) {
        Sj.getAgency(agency_id).then(function(data){
            $scope.modalData = data[0];
            $scope.modal.show();
        });
      };
      $scope.closeModal = function() {
        $scope.modal.hide();
      };
      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
})

.controller('SavedJobDetailsController', function($scope, $state, $stateParams, Dialog, Obj, LocalStorage, Sj, Jobs) {
    Jobs.get($stateParams.jobid).then(function(data){
        $scope.item = data;
    });

    if($stateParams.success){
        $scope.showMsg = true;
    }

    $scope.closeMsg = function(){
        $scope.showMsg = false;
    }

    $scope.apply = function(){
        if(!LocalStorage.get('email')){
            $state.go('login-first', { error: '1'});
            return false;
        }
        $state.go('apply-saved', { jobid: $stateParams.jobid, agency_id:$stateParams.agency_id, saved:'saved-job'});
    }
})

.controller('JobsAppliedController', function($scope, Dialog, Obj, LocalStorage, Sj){
    Sj.getJobsApplied(LocalStorage.get('id')).then(function(data){
        $scope.items = data;
    });
})

.controller('JobAlertsController', function($scope, Dialog, Obj, LocalStorage, Sj, Toast){
    $scope.job_pref = true;
    $scope.pref = [{}];
    $scope.user_pref = function(){
        Sj.checkEmail(LocalStorage.get('email')).then(function(data){
              $scope.job_position = data[0].preference;
        });
    }

    $scope.user_pref();
    
    $scope.jobPref = function(job_pref){
        $scope.job_pref = job_pref;
        $scope.pref.position = undefined;
    }


    $scope.submit = function(prefForm, pref){
        if(prefForm.$valid == false){
            Dialog.alert('Please indicate your desired position');  
            return false;
        }
        if($scope.job_pref == undefined || $scope.job_pref == false){
            var job_alert = 0;
        }
        else if($scope.job_pref == true){
            var job_alert = 1;
        }
        var applicant_id = LocalStorage.get('id');
        var dataToSend = {
              applicant_id: applicant_id,
              job_alert:job_alert,
              preference: pref.position
            }
        console.log(dataToSend);
        Sj.submitJobPref(JSON.stringify(dataToSend)).then(function(data){
            console.log(data);
            Toast.show('Desired Position Updated', 1000, 'bottom');
            $scope.user_pref();
        });
    }
})

.controller('footerController', function($scope, $state, $ionicLoading, $ionicModal, $rootScope, Sj, LocalStorage) {
    $scope.$on('authenticated', function (event, args) {
     $scope.auth = args;
    });

    if(LocalStorage.get('email')){
        $scope.auth = LocalStorage.get('firstname');
    }

    $scope.logout = function(){
        $ionicLoading.show({showBackdrop: false,});
        setTimeout(function () {
            LocalStorage.remove('email');
            LocalStorage.remove('firstname');
            LocalStorage.remove('id');
            $scope.auth = null;
            $state.go('home');
            $ionicLoading.hide();
            $rootScope.$broadcast('homeAuth', 'true');
        }, 2000);
    }

	$scope.actionSheet = function(){
      Sj.actionSheet();
    }

    $scope.$on('terms', function (event) {
     $scope.modal.show();
    });

    $ionicModal.fromTemplateUrl('index.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openTerms = function() {
        $scope.modal.show();
    };
    $scope.closeTerms = function() {
    $scope.modal.hide();
    };
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
    $scope.modal.remove();
    });

    $ionicModal.fromTemplateUrl('disclaimer.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.disclaimerModal = modal;
    });

    $scope.$on('disclaimer', function (event) {
     $scope.disclaimerModal.show();
    });

    $scope.openDisclaimer = function() {
        $scope.disclaimerModal.show();
    };
    $scope.closeDisclaimer = function() {
    $scope.disclaimerModal.hide();
    };
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
    $scope.disclaimerModal.remove();
    });

    $ionicModal.fromTemplateUrl('about.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.aboutModal = modal;
    });

    $scope.$on('about', function (event) {
     $scope.aboutModal.show();
    });

    $scope.openAbout = function() {
        $scope.disclaimerModal.show();
    };
    $scope.closeAbout = function() {
    $scope.aboutModal.hide();
    };
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
    $scope.aboutModal.remove();
    });
})

.controller('AppController', function($scope, $state, Dialog, LocalStorage) {
    $scope.toggle = function(){
        if(!LocalStorage.get('email')){
            $scope.loggedIn = false;
        }
        else{
            $scope.authUser = LocalStorage.get('firstname');
            $scope.loggedIn = true;
        }
    }

    $scope.home = function(){
        $state.go('home');
    }
})