/**
* mwsng Module
*
* Description
*/
angular.module('sj', ['starter.services'])

.factory('Sj', function(
    $http, 
    $q,
    $ionicLoading,
    $state,
    $rootScope,
    $ionicActionSheet,
    Network,
    Dialog,
    LocalStorage,
    Toast,
    transformRequestAsFormPost){

    var rootUrl = 'https://www.seamanjobsite.com/services/';
    var localUrl = 'http://tsinoy-ws14/seamanjobsitenew/services/';

    function getSearchResult(what,search_by){
        if(search_by == "Jobs"){
            var searchUrl = rootUrl + "view_jobs.php";
        }
        else if(search_by == "Agency"){
            var searchUrl = rootUrl + "view_agency.php";
        }

        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(searchUrl, {
            params:{
                    search_what:what
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getAgencyJobs(agency_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_jobs.php", {
            params:{
                    agency_id:agency_id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getAgency(agency_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_agency_details.php", {
            params:{
                    agency_id:agency_id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getJobDetails(jobid){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_job_details.php", {
            params:{
                    jobid:jobid
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getJobsApplied(applicant_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_applicantjobdetails.php", {
            params:{
                    applicant_id:applicant_id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getSeaEmployment(applicant_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_employment_sea.php", {
            params:{
                    applicant_id:applicant_id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getSeaDetails(id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_details_sea.php", {
            params:{
                    id:id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function getLandEmployment(applicant_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_employment_land.php", {
            params:{
                    applicant_id:applicant_id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }
    
    function getLandDetails(id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_details_land.php", {
            params:{
                    id:id
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function submitRegistration(params)
    {
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});

        $http({
            url: rootUrl + 'sjRegistration.php',
            method:'POST',
            transformRequest: transformRequestAsFormPost,
            data:{data:params}
        })

        .success(function(data, status, headers, config){

            var dataResolve,
                details = data.details;
            deferred.resolve(data);
        })

        .error(function(data, status, headers, config){

            Toast.show('Submission failed: No network connection', 1000, 'bottom');
            deferred.reject(data);
        })

        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function addExperience(params)
    {
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});

        $http({
            url: rootUrl + 'add_employment.php',
            method:'POST',
            transformRequest: transformRequestAsFormPost,
            data:{data:params}
        })

        .success(function(data, status, headers, config){

            var dataResolve,
                details = data.details;
            deferred.resolve(data);
        })

        .error(function(data, status, headers, config){

            Toast.show('Submission failed: No network connection', 1000, 'bottom');
            deferred.reject(data);
        })

        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function updateProfile(params)
    {
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});

        $http({
            url: rootUrl + 'update_profile.php',
            method:'POST',
            transformRequest: transformRequestAsFormPost,
            data:{data:params}
        })

        .success(function(data, status, headers, config){

            var dataResolve,
                details = data.details;
            deferred.resolve(data);
        })

        .error(function(data, status, headers, config){

            Toast.show('Submission failed: No network connection', 1000, 'bottom');
            deferred.reject(data);
        })

        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function deleteExp(id, form){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "delete_employment.php", {
            params:{
                    id:id,
                    form:form
                   }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function checkUser(user){
       var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "user.php", {
            params:{
                email:user.email,
                password:user.password
               }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function checkEmail(email){
        var deferred = $q.defer();
        if(email == undefined){
            var email_user = 'null';
        }
        else{
            var email_user = email;
        }
         $http.get(rootUrl + "email_user.php", {
            params:{
                email:email_user
               }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject();
        })
        .finally(function(){
        });
        return deferred.promise;
    }
    function checkApplied(applicant_id, job_id){
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});
         $http.get(rootUrl + "view_job_application.php", {
            params:{
                applicant_id:applicant_id,
                job_id:job_id
               }
        })
        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            Toast.show('Request Not Available', 1000, 'bottom');
            deferred.reject(data);
        })
        .finally(function(){
            $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function applyJob(params)
    {
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});

        $http({
            url: rootUrl + 'sjApplication.php',
            method:'POST',
            transformRequest: transformRequestAsFormPost,
            data:{data:params}
        })

        .success(function(data, status, headers, config){

            var dataResolve,
                details = data.details;
            deferred.resolve(data);
        })

        .error(function(data, status, headers, config){

            Toast.show('Submission failed: No network connection', 1000, 'bottom');
            deferred.reject(data);
        })

        .finally(function(){
            $ionicLoading.hide();
        });
        
        return deferred.promise;
    }

    function submitJobPref(params)
    {
        var deferred = $q.defer();
        $ionicLoading.show({showBackdrop: false,});

        $http({
            url: rootUrl + 'update_preference.php',
            method:'POST',
            transformRequest: transformRequestAsFormPost,
            data:{data:params}
        })

        .success(function(data, status, headers, config){

            var dataResolve,
                details = data.details;
            deferred.resolve(data);
        })

        .error(function(data, status, headers, config){

            Toast.show('Submission failed: No network connection', 1000, 'bottom');
            deferred.reject(data);
        })

        .finally(function(){
            $ionicLoading.hide();
        });
        
        return deferred.promise;
    }

    function actionSheet()
    {
        $ionicActionSheet.show({
         buttons: [
           { text: '<i class="icon ion-android-list positive"></i> Terms of Use' },
           { text: '<i class="icon ion-android-alert positive"></i> Disclaimer' },
           { text: '<i class="icon ion-information-circled positive"></i> About Us' }
         ],
         titleText: 'Menu',
         cancelText: 'Cancel',
         cancel: function() {
              // add cancel code..
         },
         buttonClicked: function(index) {
            if (index==0)
            {
                $rootScope.$broadcast('terms');
                return true;
            } else if(index==1){
                $rootScope.$broadcast('disclaimer');
                return true;
            } else if(index==2){
                $rootScope.$broadcast('about');
                return true;
            }
         }
       });
    }

    function positionList(){
        var deferred = $q.defer();
        // $ionicLoading.show({showBackdrop: false,});
        
        $http.get(rootUrl + "view_position.php")

        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            // Toast.show('Position List Not Available', 3000, 'bottom');
            // deferred.reject(data);
            deferred.resolve('failed');
        })
        .finally(function(){
            // $ionicLoading.hide();
        });
        return deferred.promise;
    }

    function vesselTypeList(){
        var deferred = $q.defer();
        // $ionicLoading.show({showBackdrop: false,});
        
        $http.get(rootUrl + "view_vessel_type.php")

        .success(function(data, status, headers, config){
            deferred.resolve(data);
        })
        .error(function(){
            // Toast.show('Vessel Type List Not Available', 3000, 'bottom');
            // deferred.reject(data);
            deferred.resolve('failed');
        })
        .finally(function(){
            // $ionicLoading.hide();
        });
        return deferred.promise;
    }

    return {
        getSearchResult:getSearchResult,
        getAgencyJobs:getAgencyJobs,
        getAgency:getAgency,
        getJobDetails:getJobDetails,
        getJobsApplied:getJobsApplied,
        getSeaEmployment:getSeaEmployment,
        getSeaDetails:getSeaDetails,
        getLandEmployment:getLandEmployment,
        getLandDetails:getLandDetails,
        submitRegistration:submitRegistration,
        addExperience:addExperience,
        updateProfile:updateProfile,
        deleteExp:deleteExp,
        checkUser:checkUser,
        checkEmail:checkEmail,
        checkApplied:checkApplied,
        applyJob:applyJob,
        submitJobPref:submitJobPref,
        actionSheet:actionSheet,
        positionList:positionList,
        vesselTypeList:vesselTypeList
    }

})